<?php
/**
 * Created by PhpStorm.
 * User: ehrapov
 * Date: 07.02.2019
 * Time: 11:10
 */

class ModelExtensionShippingDellindeliverySetting extends Model
{

    public function getRequiredFields(){
        $query = $this->db->query("SELECT * FROM ".DB_PREFIX."dellin_delivery_properties WHERE prop_required = 1");
        return $query->rows;
    }

    public function getSettingProps(){
        $query = $this->db->query(
                "SELECT * FROM ".DB_PREFIX."dellin_delivery_properties_categories category
                  LEFT JOIN ".DB_PREFIX."dellin_delivery_properties props
                  ON  props.prop_cat = category.cat_id
                  ORDER BY props.prop_sort");
        $properties = array();
        $cat_query = $this->db->query("SELECT * FROM ".DB_PREFIX."dellin_delivery_properties_categories");
        foreach ($cat_query -> rows as $category){
            $properties[$category['cat_id']] =  array('cat_code'=>$category['cat_code'],'cat_name'=>$category['cat_name']);
        }
        foreach($query->rows as $property){
                $props = array(
                'prop_id'   => $property['prop_id'],
                'prop_name' => $property['prop_name'],
                'prop_code' => $property['prop_code'],
                'prop_type' => $property['prop_type'],
                'prop_cat'  => $property['prop_cat'],
                'prop_required' =>$property['prop_required'],
                'prop_sort' => $property['prop_sort'],
                'prop_value'=> ""

            );
            if($property['prop_type'] == 'select'){
                $query = $this->db->query("SELECT * FROM ".DB_PREFIX."dellin_delivery_property_variants WHERE prop_id ='".$property['prop_id']."'");
                if($this->db->countAffected()){
                    $prop_value = false;
                    foreach($query->rows as $variant){
                        $props['prop_variants'][] = array(
                            'variant_value' => $variant['variant_value'],
                            'variant_name'  => $variant['variant_name']
                        );
                        if(!$prop_value) $prop_value = $variant['variant_value'];
                    }
                    $props['prop_value'] = $prop_value;
                }

            }

            $properties[$property['cat_id']]['properties'][$props['prop_code']] = $props;
        }
        return $properties;
    }

    public function getBlankSetting(){
        $setting = $this->getSettingProps();
        return $setting;
    }

    public function getVariants($prop_id){
        $query = $this->db->query("SELECT * FROM ".DB_PREFIX."dellin_delivery_property_variants WHERE prop_id=".$prop_id);
        $result = array();
        foreach ($query->rows as $variant) {
            $result[] = $variant;
        }
        return $result;
    }

    public function getSetting($profile_id = Null) {
        $setting_data = array();
        $query = $this->db->query(
            "SELECT * FROM ".DB_PREFIX."dellin_delivery_setting setting
              LEFT JOIN ".DB_PREFIX."dellin_delivery_properties props
              ON  props.prop_id = setting.prop_id
              WHERE profile_id = '" . (int)$profile_id ."'");
        foreach ($query->rows as $result) {
            $setting_data[$result['prop_code']] = $result;
            if($result['prop_type'] == 'select'){
                $setting_data[$result['prop_code']]['prop_variants'] = $this->getVariants($result['prop_id']);
            }

        }
        return $setting_data;
    }

    public function saveSettings($profileId,$props){
        $valuesStr = "";
        foreach($props as $index => $prop){
            $valuesStr .= "(".$profileId.",".$prop['prop_id'].",'".$prop['prop_value']."')".(((count($props)-1) == $index)?"":",");
        }

        $result = $this->db->query("INSERT INTO `".DB_PREFIX."dellin_delivery_setting` (`profile_id`,`prop_id`,`prop_value`) VALUES ".$valuesStr." ON DUPLICATE KEY UPDATE `prop_value`=VALUES(`prop_value`);");
        return $result;
    }
}