<?php
class ControllerDellindeliveryAjax extends Controller {
    public function index() {
        $this->load->language('dellindelivery/ajax');

    }

    public function getOrderStatus(){
        $this->load->model('extension/shipping/dellindelivery');
        $this->load->model('extension/shipping/dellindelivery/delivery');
        $params = $this->model_extension_shipping_dellindelivery_delivery->getDeliveryParams($this->request->post['orderId']);
        if(!empty($params['tracking'])){
            $orderStatus = $this->model_extension_shipping_dellindelivery->GetOrderStatus(str_replace('dellindelivery.dellindelivery','',$params['shipping_code']),$params['tracking']);
        }else{
            $orderStatus = ['state'=>'process','state_name'=>'В обработке'];
        }

        echo json_encode($orderStatus);
    }

    public function getModuleMode(){
        $this->load->model('setting/setting');
        $mode = $this->model_setting_setting->getSetting('shipping_dellindelivery')['shipping_dellindelivery_module_mode'];
        if(isset($mode)){
            $result = array('status'=>'ok','mode'=>$mode);
        }else{
            $result = array('status'=>'error','text'=>'Нет информации о режиме модуля');
        }
        echo json_encode($result);
    }

    public function getDeliverySettings(){
        $this->load->model('extension/shipping/dellindelivery/setting');
        if(isset($this->request->post['profileId'])){
            $profileSettings = $this->model_extension_shipping_dellindelivery_setting->getSetting($this->request->post['profileId']);
            $data['profile_settings'] = $profileSettings;
            for($n = 0;$n<=24;$n++){
                if($n == 24){
                    $arTimeValues["23:59"] = "23:59";
                }else{
                    $time = (($n<10)?"0":"").$n.":00";
                    $arTimeValues[$time]= $time;
                }
            }
            $this->request->post['api_key']=$profileSettings['api_key']['prop_value'];
            $city = $this->load->controller('extension/shipping/dellindelivery/getCityKladr');


            if($profileSettings['is_goods_unloading']['prop_value'] == 0){
                $terminalData = array(
                    "appkey" =>$profileSettings['api_key']['prop_value'],
                    "code" => $city->code,
                    "direction" => "derival"
                );
                $arTerminalIdValues = array();
                unset($this->session->data['current_terminals']);
                if(isset($this->session->data['current_terminals'])){
                    foreach ($this->session->data['current_terminals'] as $terminal){
                        $arTerminalIdValues[$terminal['id']] = $terminal['address'];
                    }
                }else{
                    $terminalsOb = DellindeliveryApicore::sendApiRequest('requestTerminal',$terminalData);
                    $terminalsInfo = DellindeliveryApicore::GetTerminals($profileSettings['api_key']['prop_value']);
                    if($terminalsInfo) {
                        foreach ($terminalsOb->terminals as $terminal) {
                            if (isset($terminalsInfo[$terminal->city_code]['terminals'][$terminal->id]->receiveCargo) && $terminalsInfo[$terminal->city_code]['terminals'][$terminal->id]->receiveCargo) { //если терминал может принять товар
                                $arTerminalIdValues[$terminal->id] = $terminal->address;
                            }
                        }
                    }
                }

                $data['delivery_fields'][] =  array(
                    'name'=>'Терминал',
                    'type'=>'select',
                    'code'=>'TERMINAL_ID',
                    'dataCode'=>'TERMINAL_ADDRESS',
                    'dataName'=>'Адрес терминала',
                    'require'=>true,
                    'values'=>$arTerminalIdValues
                );
            }else{
                $data['delivery_fields'] = array(
                    array(
                        'name'=>'удобное время получения (начало)',
                        'type'=>'select',
                        'code'=>'DELLIN_DELIVERYTIME_START',
                        'values'=>$arTimeValues,
                        'require'=>true
                    ),
                    array(
                        'name'=>'удобное время получения (конец)',
                        'type'=>'select',
                        'code'=>'DELLIN_DELIVERYTIME_END',
                        'values'=>$arTimeValues,
                        'require'=>true,
                    ),
                    array(
                        'name'=>'Улица',
                        'type'=>'apiAutocomplete',
                        'code'=>'DELLIN_DELIVERY_STREET',
                        'dataCode'=>'STREET_KLADR',
                        'dataName'=>'Кладр улицы',
                        'require'=>true,
                        'class'=> 'street_autocomplete'
                    ),
                    array(
                        'name'=>'Дом',
                        'type'=>'text',
                        'code'=>'DELLIN_DELIVERY_HOUSE_NUM',
                        'require'=>true,
                    ),
                    array(
                        'name'=>'Корпус',
                        'type'=>'text',
                        'code'=>'DELLIN_DELIVERY_BUILDING_NUM',
                        'require'=>false,
                    ),
                    array(
                        'name'=>'Строение',
                        'type'=>'text',
                        'code'=>'DELLIN_DELIVERY_STRUCTURE_NUM',
                        'require'=>false,
                    ),
                    array(
                        'name'=>'Квартира/офис',
                        'type'=>'text',
                        'code'=>'DELLIN_DELIVERY_FLAT_NUM',
                        'require'=>false,
                    ),
                );
            }
            if($this->request->post['userType'] == 'juridical'){
                $apiKey = $profileSettings['api_key']['prop_value'];

                $opfList = $this->getOpf($apiKey);
                $countries = $opfList['countries'];
                $arOpf = $opfList['opf'];
                $data['juridical_info'] =array(
                    array(
                        'name'=>'Страна регистрации ОПФ',
                        'type'=>'select',
                        'code'=>'JURIDICAL_OPF_COUNTRY',
                        'dataCode'=>'JURIDICAL_OPF_COUNTRY_NAME',
                        'dataName'=>'Название страны регистрации',
                        'values'=>$countries,
                        'default'=>'0x8f51001438c4d49511dbd774581edb7a',
                        'require'=>true,
                    ),
                    array(
                        'name'=>'ОПФ',
                        'type'=>'select',
                        'code'=>'JURIDICAL_OPF',
                        'dataCode'=>'JURIDICAL_OPF_NAME',
                        'dataName'=>'Название ОПФ',
                        'values'=>$arOpf['0x8f51001438c4d49511dbd774581edb7a'],
                        'default'=> '0x92ee03691f25a9fe4be9910cd87ca9ca',
                        'require'=>true,
                    ),
                    array(
                        'name'=>'Название компании',
                        'type'=>'text',
                        'code'=>'JURIDICAL_COMPANY_NAME',
                        'require'=>true,
                    ),
                    array(
                        'name'=>'ИНН',
                        'type'=>'text',
                        'code'=>'JURIDICAL_INN',
                        'require'=>true,
                    ),
                    array(
                        'name'=>'Город',
                        'type'=>'apiAutocomplete',
                        'code'=>'JURIDICAL_CITY',
                        'dataCode'=>'JURIDICAL_CITY_KLADR',
                        'dataName'=>'Кладр города',
                        'require'=>true,
                        'class'=> 'city_autocomplete'
                    ),
                    array(
                        'name'=>'Улица',
                        'type'=>'apiAutocomplete',
                        'code'=>'JURIDICAL_STREET',
                        'dataCode'=>'JURIDICAL_STREET_KLADR',
                        'parentKladrCode'=>'JURIDICAL_CITY',
                        'dataName'=>'Кладр улицы',
                        'require'=>true,
                        'class'=> 'street_autocomplete'
                    ),
                      array(
                          'name'=>'Дом',
                          'type'=>'text',
                          'code'=>'JURIDICAL_HOUSE_NUM',
                          'require'=>true,
                      ),
                    array(
                        'name'=>'Строение',
                        'type'=>'text',
                        'code'=>'JURIDICAL_BUILDING_NUM',
                        'require'=>false,
                    ),
                    array(
                        'name'=>'Корпус',
                        'type'=>'text',
                        'code'=>'JURIDICAL_STRUCTURE_NUM',
                        'require'=>false,
                    ),
                    array(
                        'name'=>'Квартира/офис',
                        'type'=>'text',
                        'code'=>'JURIDICAL_FLAT_NUM',
                        'require'=>false,
                    ),
                );
            }
            $this->session->data['shipping_address']['city_kladr']=$city->code;
            $this->response->setOutput($this->load->view('dellindelivery/ajax', $data));
        }
    }

    public function saveAdditionalParamsToSession(){
        $additionalParams = $this->request->post;
        $this->session->data['shipping_method']['additional_params'] = $additionalParams;
        return "ok";
    }

    public function getDeliveryData(){
        $this->load->model('extension/shipping/dellindelivery');
        $this->load->model('extension/shipping/dellindelivery/delivery');
        $this->load->model('checkout/order');
        $params = $this->model_extension_shipping_dellindelivery_delivery->getDeliveryParams($this->request->post['orderId']);
        $totals = $this->model_checkout_order->getOrderTotals($this->request->post['orderId']);
        foreach($totals as $totalResult){
            $params['totalResults'][$totalResult['code']] = $totalResult;
        }
        if(!empty($params['tracking'])){
            $orderStatus = $this->model_extension_shipping_dellindelivery->GetOrderStatus(str_replace('dellindelivery.dellindelivery','',$params['shipping_code']),$params['tracking']);
            $params['delivery_status']=$orderStatus;
        }

        echo json_encode($params);
    }

    /**
     * post params: orderId, orderUpdated
     */
    public function createOrder(){
        $this->load->model('extension/shipping/dellindelivery/delivery');
        $this->load->model('extension/shipping/dellindelivery');
        $orderDeliveryParams = $this->model_extension_shipping_dellindelivery_delivery->getDeliveryParams($this->request->post['orderId']);
        $this->load->model('checkout/order');
        $this->load->model('catalog/product');
        $orderProducts = $this->model_checkout_order->getOrderProducts($this->request->post['orderId']);
        $totalQuantity = 0;
        $maxWeight = 0;
        $maxLength = 0;
        $maxWidth = 0;
        $maxHeight = 0;
        $freightName = "";// названия товаров в заказе одной строкой (нужно для отправки заявки)
        foreach ($orderProducts as $index => &$orderProduct) {
            $product = $this->model_catalog_product->getProduct($orderProduct['product_id']);
            $orderProduct['sku'] = $product['sku'];
            $orderProduct['weight'] = $product['weight'];
            if($product['weight'] > $maxWeight) $maxWeight = $product['weight'];
            $orderProduct['weight_class_id'] =  $product['weight_class_id'];
            $orderProduct['length'] =  $product['length'];
            if($product['length'] > $maxLength) $maxLength= $this->model_extension_shipping_dellindelivery->convertToMM($product['length'], $product['length_class_id']);
            $orderProduct['length_class_id'] =  $product['length_class_id'];
            $orderProduct['width'] =  $product['width'];
            if($product['width'] > $maxWidth) $maxWidth= $this->model_extension_shipping_dellindelivery->convertToMM($product['width'], $product['length_class_id']);
            $orderProduct['height'] =  $product['height'];
            if($product['height'] > $maxHeight) $maxHeight= $this->model_extension_shipping_dellindelivery->convertToMM($product['height'], $product['length_class_id']);
            $totalQuantity += $orderProduct['quantity'];
            $freightName .=(($index != 0)?",":"").$orderProduct['name'];
        }
        $orderProductsData = array(
            'totalQuantity' =>$totalQuantity,
            'freightName'   =>$freightName,
            'maxWeight'     => $maxWeight,
            'maxHeight'     => $maxHeight,
            'maxLength'     => $maxLength,
            'maxWidth'      => $maxWidth,
            'products'      =>$orderProducts
        );
        $address['city'] = $orderDeliveryParams['shipping_city'];
        $address['shipping_zone'] = $orderDeliveryParams['shipping_zone'];

        $this->load->model('extension/shipping/dellindelivery');
        $profileId = str_replace("dellindelivery.dellindelivery","", $orderDeliveryParams['shipping_code']);
        $profileSettings = $this->model_extension_shipping_dellindelivery_setting->getSetting($profileId);

        if($this->request->post['orderUpdated'] == "false"){
            $result = $this->recalculateOrder($address,$orderProductsData,$profileSettings,json_decode($orderDeliveryParams['additional_delivery_params']));
        }else{
            $result = $this->model_extension_shipping_dellindelivery->createOrder($orderDeliveryParams,$profileSettings,$orderProductsData,$this->request->post['deliveryType']);
        }


        echo json_encode($result);
    }


    public function recalculateOrder($address,$orderProductsData,$profileSettings,$additional_params){
        $oldCost = floatval($additional_params->DELIVERY_COST->value);
        $oldDeliveryTerm = explode(' ',$additional_params->DELIVERY_TIME->value)[0];
        $this->load->model('extension/shipping/dellindelivery');
        $arrivalKladr = isset($additional_params->STREET_KLADR->value)?$additional_params->STREET_KLADR->value:false;
        $config = $profileSettings;
        $config['produceDate'] = false;
        if(isset($additional_params->DELIVERY_LOADING_DATE->value)){
            $savedDate = date_create($additional_params->DELIVERY_LOADING_DATE->value);
            $today = date_create(date('Y-m-d',time()));
            if($savedDate >= $today ){
                $config['produceDate'] = $additional_params->DELIVERY_LOADING_DATE->value;
            }
        }
        $calcResult = $this->model_extension_shipping_dellindelivery->Calculate($address,$orderProductsData['products'],$config,$arrivalKladr);
        if(isset($calcResult['body'][2])){
            $datediff = $this->model_extension_shipping_dellindelivery->dateDifference($calcResult['body'][2],date('Y-m-d',time()));
        }
        $arDeliveryTerm = explode(' ',$calcResult['body'][1]);
        $daysCount = $arDeliveryTerm[0];

        /*$oldCost = 0;
        $oldDeliveryTime = 0;*/
        $newDeliveryTerm = (int) $daysCount + $datediff;
        if(isset($calcResult['terminalTime'])){
            $calcResult['timeChanged'] = true;
        }
        if((int) $newDeliveryTerm != (int) $oldDeliveryTerm){
            $newTerm = $newDeliveryTerm;
            $termChanged = true;
        }
        $newCost = floatval($calcResult['body'][0]);
        $additional_params->DELIVERY_LOADING_DATE->value = date('d-m-Y',strtotime($calcResult['body'][2]));
        if($oldCost != $newCost){
            $priceChanged = $newCost;
        }
        if(isset($priceChanged)){
            $additional_params->DELIVERY_COST->value = $priceChanged;
            $calcResult['body'][0] = $priceChanged;
            $calcResult['priceChanged'] = true;
        }
        if(isset($termChanged)) {
            $calcResult['body'][1] = $newDeliveryTerm;
            $pluralform = $this->model_extension_shipping_dellindelivery->plural($newTerm,"день","дня","дней");
            $newTermStr = implode(" ",array($newTerm,$pluralform));
            $additional_params->DELIVERY_TIME->value = $newTermStr;
            $calcResult['body'][1] = $newTermStr;
            $calcResult['dateChanged'] = true;
        }
        if(isset($newTerm) || isset($priceChanged) ){
            $this->load->model('extension/shipping/dellindelivery/delivery');
            $this->load->model('extension/shipping/dellindelivery');
            $this->model_extension_shipping_dellindelivery_delivery->saveDeliveryParams($this->request->post['orderId'],$additional_params);
        }


        $calcResult['body'][2] = date('d-m-Y',strtotime($calcResult['body'][2]));
        return $calcResult;
    }

    public function findKladr(){
        if(!class_exists('DellindeliveryApicore')) $this->load->library('DellindeliveryApicore');
        $this->load->model('extension/shipping/dellindelivery/setting');
        $this->load->model('extension/shipping/dellindelivery');
        $profileSettings = $this->model_extension_shipping_dellindelivery_setting->getSetting($this->request->post['profileId']);
        if($this->request->post['ajaxAction'] == 'SEARCH_STREET'){
            $arParams = array(
                "appkey"    => $profileSettings['api_key']['prop_value'],
                "code"      => isset($this->request->post['parentKladr'])?$this->request->post['parentKladr'] : $this->session->data['shipping_address']['city_kladr'],
                "street"    => $this->request->post['query'],
                "limit"     => isset($this->request->post['count'])?$this->request->post['count']:2
            );
            $streets = DellindeliveryApicore::GetStreetKladr($arParams);
            $result = $streets['streets'];
        }else{
            $cityData = array(
                "appkey" => $profileSettings['api_key']['prop_value'],
                "q"      =>$this->request->post['query'],
                "limit"  =>  isset($this->request->post['count'])?$this->request->post['count']:2
            );
            $cities = DellindeliveryApicore::sendApiRequest('cityInfo',$cityData);
            $result = $cities->cities;
        }
        echo json_encode($result,JSON_UNESCAPED_UNICODE);
    }
    public function getOpf($apiKey=false){
        if(!class_exists('DellindeliveryApicore')) $this->load->library('DellindeliveryApicore');
        $arCountriesList = array();
        $arOpfList = array();
        if(isset($this->request->get['profileId']) && !$apiKey){
            $this->load->model('extension/shipping/dellindelivery/setting');
            $profileSettings = $this->model_extension_shipping_dellindelivery_setting->getSetting($this->request->get['profileId']);
            $apiKey = $profileSettings['api_key']['prop_value'];
        }
        if(isset($apiKey) && strlen(trim($apiKey)) > 0){
            $opfList = DellindeliveryApicore::GetOpfList($apiKey);
            if(isset($opfList)){
                $countries = DellindeliveryApicore::GetCountries($apiKey);
                foreach($countries as $country){
                    $arCountriesList[$country['countryUID']] = $country['country'];
                }
                foreach($opfList['list'] as $id => $opf){
                    $arOpfList[$opf['countryUID']][$opf['uid']] = $opf['name'];
                    asort($arOpfList[$opf['countryUID']]);
                }
                asort($arCountriesList);
            }
        }
        if(isset($this->request->get['ajax'])){
            echo json_encode( array('opf'=>$arOpfList,'countries'=>$arCountriesList));
        }else{
            return array('opf'=>$arOpfList,'countries'=>$arCountriesList);
        }

    }


}