<?php
class ModelExtensionShippingDellindelivery extends Model {
    // Загрузка настроек из базы данных
    public function getQuote($address)
    {
        $this->load->model('extension/shipping/dellindelivery/setting');
        $this->load->model('extension/shipping/dellindelivery/profile');
        $this->load->library('DellindeliveryApicore');
        $this->load->model('setting/setting');
        $this->load->language('extension/shipping/dellindelivery');
        $status = $this->config->get('shipping_dellindelivery_status');
        $method_data = array();
        if ($status) {
            $products = array();
            foreach ($this->cart->getProducts() as $product) {
                if ($product['shipping']) {
                    $products[] = $product;
                }
            }
            $quote_data = array();

            $profiles = $this->model_extension_shipping_dellindelivery_profile->getList();
            foreach($profiles as $profile){
                if($profile['profile_status'] == 1){
                    $profileSettings = $this->model_extension_shipping_dellindelivery_setting->getSetting($profile['profile_id']);
                    $calcResult = $this->Calculate($address,$products,$profileSettings);
                    if($calcResult['status'] == 'OK'){
                        if(isset($calcResult['body'][2])){
                            $datediff =$this->dateDifference($calcResult['body'][2],date('Y-m-d',time()));
                            $arDate = explode(" ",$calcResult['body'][1]);
                            $newDate = (int) $arDate[0]; /*+ $datediff;*/
                        }
                        if(isset($newDate)){
                            if($newDate == 0) $newDate = 1;
                            $pluralForm = $this->plural($newDate,"день","дня","дней");
                            $newDateStr = implode(" ",array($newDate,$pluralForm));
                        }else{
                            $newDateStr="";
                        }

                        $shipping_cost = $calcResult['body'][0];
                        $quote_data['dellindelivery'.$profile['profile_id']] = array(
                            'code'         => 'dellindelivery.dellindelivery'.$profile['profile_id'],
                            'title'        => $this->language->get('dellin_text_description').": ".$profile['profile_name'],
                            'cost'         => $shipping_cost,
                            'tax_class_id' => 0,//$this->config->get('shipping_item_tax_class_id'),
                            'text'         => '<span class="shipping_data" data-cost="'.$shipping_cost.'" data-term="'.$newDateStr.'" data-loading-date="'.date('d-m-Y',strtotime($calcResult['body'][2])).'">'.$this->currency->format($shipping_cost, $this->session->data['currency'])." Срок: ".$newDateStr.". Дата отправки : ".date('d-m-Y',strtotime($calcResult['body'][2])).'</span>'
                        );
                        $method_data = array(
                            'code'       => 'dellindelivery'.$profile['profile_id'],
                            'title'      => $this->language->get('dellin_text_description'),
                            'quote'      => $quote_data,
                            'sort_order' => $this->config->get('shipping_item_sort_order'),
                            'error'      => false
                        );
                    }
                }
            }


        }
        return $method_data;
    }

    public function getDeliveryOrderData($orderDeliveryParams,$profileSettings,$orderProductsData,$deliveryType){
        if(!class_exists('DellindeliveryApicore')) $this->load->library('DellindeliveryApicore');
        $arConfig= array('api_key'=>$profileSettings['api_key']['prop_value'],'login'=>$profileSettings['login']['prop_value'],'password'=>$profileSettings['password']['prop_value']);
        if($arConfig['login'] && $arConfig['password']){
            $sessionID = $this::getDellinSessionId($arConfig);
        }
        $opfList = DellindeliveryApicore::GetOpfList($arConfig['api_key'])['list'];
        foreach($opfList as $opf){
            $arOpfList[$opf['uid']] = $opf;
        }
        $address['city'] = $orderDeliveryParams['shipping_city'];
        $address['shipping_zone'] = $orderDeliveryParams['shipping_zone'];
        $calculatorData = $this->GetDeliveryData($address,$orderProductsData['products'],$profileSettings);
        $deliveryDelay = $profileSettings['delivery_delay']['prop_value']?:0;

        $convertLength = (DellindeliveryApicore::convertMMtoM($orderProductsData['maxLength'])>0)?DellindeliveryApicore::convertMMtoM($orderProductsData['maxLength']):0.01;
        $convertWidth = (DellindeliveryApicore::convertMMtoM($orderProductsData['maxWidth'])>0)?DellindeliveryApicore::convertMMtoM($orderProductsData['maxWidth']):0.01;
        $convertHeight = (DellindeliveryApicore::convertMMtoM($orderProductsData['maxHeight'])>0)?DellindeliveryApicore::convertMMtoM($orderProductsData['maxHeight']):0.01;
        $produceData = array(
            "appKey"                => $profileSettings['api_key']['prop_value'],
            "produceDate"           => date("Y-m-d",mktime(0, 0, 0, date("m")  , date("d")+$deliveryDelay, date("Y"))), //ориентировочная минимальная дата (сегодня + дней из настроек)
            "sizedVolume"           => $calculatorData['sizedVolume'],
            "sizedWeight"           => $calculatorData['sizedWeight'],
            "derivalPoint"          => $calculatorData['derivalPoint'],
            "derivalDoor"           => $calculatorData['derivalDoor'],
            "deliveryType"          => "1",
            "derivalPeriodVisit"    => array(
                "workStart" => $profileSettings['work_start']['prop_value'],
                "workEnd"   => $profileSettings['work_end']['prop_value']
            ),
            "length"          => $convertLength,
            "width"           => $convertWidth,
            "height"          => $convertHeight
        );
        if(isset($deliveryData['oversizedWeight'])){
            $produceData["oversizedWeight"] = $calculatorData['oversizedWeight'];
        }
        if(isset($deliveryData['oversizedVolume'])){
            $produceData["oversizedVolume"] = $calculatorData['oversizedVolume'];
        }
        $produceDate = $this->GetProduceDate($produceData,$profileSettings);
        if(isset($produceDate->nearestDate)){//если дата не подошла
            $nearestDate = $produceDate->nearestDate;
        }else{
            $nearestDate = date("Y-m-d",mktime(0, 0, 0, date("m")  , date("d")+$deliveryDelay, date("Y")));
        }

        //коды ИП для разных стран
        $receiverPPCodes = array(
            "176" => "0xab91feea04f6d4ad48df42161b6c2e7a"
        );

        $deliveryData = array(
            "appKey"    => $profileSettings['api_key']['prop_value'],
            "delivery"  => array(
                "deliveryType" => array(
                    "type"  => $deliveryType,
                    "payer" => "sender"
                ),
                "simpleShipping" => "false",
                "derival"   => array(
                    "produceDate" => $nearestDate,
                    "variant"     => ($profileSettings['is_goods_loading']['prop_value'] == "1")?"address":"terminal",
                    "payer"       => "sender",
                ),
                "arrival"   => array(
                    "variant"     => ($profileSettings['is_goods_unloading']['prop_value'] == "1")?"address":"terminal",
                    "payer"       => "sender",
                ),
            ),
            "members" => array(
                "requester" => array(
                    "role"  => "sender",
                    "email" => $profileSettings['request_email']['prop_value'] //почта
                ),
                "sender" => array(
                    "counteragent"=> array(
                        "form" => $profileSettings['sender_form']['prop_value'],
                        "name" => str_replace('&quot;',"'",$profileSettings['sender_name']['prop_value']),
                        "inn"  => $profileSettings['sender_inn']['prop_value'],
                        "juridicalAddress" => ($arOpfList[$profileSettings['sender_form']['prop_value']]['juridical'] == 1)?array(
                            "street"    => $profileSettings['sender_juridical_kladr_street']['prop_value'],
                            "house"     => $profileSettings['sender_juridical_house']['prop_value'],
                        ):array(),
                        "isAnonym" => false
                    ),
                    "contactPersons" => array(
                        array(
                            "name" => $profileSettings['sender_contact_person_name']['prop_value'],
                            "save" => false
                        )
                    ),
                    "phoneNumbers" => array(
                        array(
                            "number" => $profileSettings['sender_contact_phone']['prop_value']
                        )
                    ),
                    "email" =>  $profileSettings['sender_contact_email']['prop_value']
                ),
                "receiver" => array(
                    "counteragent" => array(
                        "form" => $receiverPPCodes[$orderDeliveryParams['shipping_country_id']],//физическое лицо. Если юр. лицо, то ниже counteragent изменится на массив параметров для юр. лица
                    ),
                    "contactPersons" => array(
                        array(
                            "name" => $orderDeliveryParams['email'],
                            "save" => false
                        )
                    ),
                    "phoneNumbers"=> array(
                        array(
                            "number" =>  preg_replace('/[+\-\(\)\s]/m', '', $orderDeliveryParams['telephone'])
                        )
                    ),
                    "email" => $orderDeliveryParams['email']
                ),
            ),
            "cargo" => array(
                "quantity"    => $calculatorData['quantity'],
                "length"      => $convertLength,
                "width"       => $convertWidth,
                "height"      => $convertHeight,
                "weight"      => round($calculatorData['sizedWeight'],3),
                "totalVolume" => round($calculatorData['sizedVolume'],3),
                "totalWeight" => round($calculatorData['sizedWeight'],3),
                "insurance" => array(
                    "statedValue" => ($profileSettings['is_insurance_goods_with_declared_price']['prop_value'] == 1)? $this->getOrderPrice($orderProductsData['products']):0,
                    "payer"       => "sender",
                    "term"        => false
                ),
                "freightName" => $orderProductsData['freightName']
            ),
            "payment"=> array(
                "type" => "noncash",
                "primaryPayer" => "sender"
            ),
            'productInfo'=>array(
                'type'=> 4,
                'productType'=> 5,
                'info'=>array(
                    array(
                        'param'=> 'module version',
                        'value'=> 'beta'
                    )
                )
            )
        );
        if(isset($sessionID)){
            $deliveryData["sessionID"] = $sessionID;
        }
        /*echo "<pre>";
        var_dump($config['COUNTERAGENT']['VALUE']);
        echo "</pre>";
        die();*/
        if($profileSettings['counteragent']['prop_value'] !== "" && $profileSettings['counteragent']['prop_value'] !== null){
            $deliveryData['members']['requester']["uid"] = $profileSettings['counteragent']['prop_value'];
        }
        if(!empty($profileSettings['sender_juridical_building']['prop_value'])) $deliveryData['members']['sender']['counteragent']['juridicalAddress']['building'] = $profileSettings['sender_juridical_building']['prop_value'];
        if(!empty($profileSettings['sender_juridical_structure']['prop_value'])) $deliveryData['members']['sender']['counteragent']['juridicalAddress']['structure'] = $profileSettings['sender_juridical_structure']['prop_value'];
        if(!empty($profileSettings['sender_juridical_flat_num']['prop_value'])) $deliveryData['members']['sender']['counteragent']['juridicalAddress']['flat'] = $profileSettings['sender_juridical_flat_num']['prop_value'];
        $additionalParams = json_decode($orderDeliveryParams['additional_delivery_params']);
        if($additionalParams->USER_TYPE->value == "juridical"){
            $deliveryData['members']['receiver']['counteragent'] =
                array(
                    "form" => $additionalParams->JURIDICAL_OPF->value,
                    "name" => $additionalParams->JURIDICAL_COMPANY_NAME->value,
                    "inn"  => $additionalParams->JURIDICAL_INN->value,
                    "juridicalAddress" => array(
                        "street"    => $additionalParams->JURIDICAL_STREET_KLADR->value?:"",
                        "house"     => $additionalParams->JURIDICAL_HOUSE_NUM->value?:"",
                    ),
                    "isAnonym" =>false
                );
            if(!empty($additionalParams->JURIDICAL_BUILDING_NUM->value)) $deliveryData['members']['receiver']['counteragent']['juridicalAddress']["building"] = $additionalParams->JURIDICAL_BUILDING_NUM->value;
            if(!empty($additionalParams->JURIDICAL_STRUCTURE_NUM->value)) $deliveryData['members']['receiver']['counteragent']['juridicalAddress']["structure"] = $additionalParams->JURIDICAL_STRUCTURE_NUM->value;
            if(!empty($additionalParams->JURIDICAL_FLAT_NUM->value)) $deliveryData['members']['receiver']['counteragent']['juridicalAddress']["flat"] = $additionalParams->JURIDICAL_FLAT_NUM->value;
        }
        if($additionalParams->USER_TYPE->value == "physical"){
            $deliveryData['members']['receiver']['counteragent']['name'] = $orderDeliveryParams['firstname']." ".$orderDeliveryParams['lastname'];
            $deliveryData['members']['receiver']['counteragent']['phone'] =  preg_replace('/[+\-\(\)\s]/m', '',$orderDeliveryParams['telephone']);
            $deliveryData['members']['receiver']['counteragent']['isAnonym'] = true;
            $deliveryData['members']['receiver']['dataForReceipt'] = array('send'=>false);
        }
        if($profileSettings['is_goods_loading']['prop_value'] != "1"){
            $deliveryData["delivery"]["derival"]["terminalID"] = $profileSettings['terminal_id']['prop_value'];
        }else{
            $deliveryData["delivery"]["derival"]["address"]['street'] = $profileSettings['loading_address']['prop_value'];
            $deliveryData["delivery"]["derival"]["address"]['house'] = $profileSettings['loading_house_num']['prop_value'];
            $deliveryData["delivery"]["derival"]["time"] = array(//если указан адрес
                "worktimeStart" => $profileSettings['work_start']['prop_value'],
                "worktimeEnd"   => $profileSettings['work_end']['prop_value'],
            );
            if(isset($profileSettings['work_break_start']['prop_value']) && !empty($profileSettings['work_break_start']['prop_value'])){
                $deliveryData["delivery"]["derival"]["time"]["breakStart"] = $profileSettings['work_break_start']['prop_value'];
            }
            if(isset($profileSettings['work_break_end']['prop_value']) && !empty($profileSettings['work_break_end']['prop_value'])){
                $deliveryData["delivery"]["derival"]["time"]["breakEnd"] = $profileSettings['work_break_end']['prop_value'];
            }
            $loadingRequirements = array();
            if(!empty($profileSettings['loading_type']['prop_value'])) $loadingRequirements[] = $profileSettings['loading_type']['prop_value'];
            if(!empty($profileSettings['loading_transport_requirements']['prop_value'])) $loadingRequirements[] = $profileSettings['loading_transport_requirements']['prop_value'];
            if(!empty($profileSettings['loading_additional_equipment']['prop_value'])) $loadingRequirements[] = $profileSettings['loading_additional_equipment']['prop_value'];
            if(!empty($loadingRequirements)) $deliveryData["delivery"]["derival"]['requirements'] = $loadingRequirements;
        }
        if($profileSettings['is_goods_unloading']['prop_value']!== "1"){
            $deliveryData["delivery"]["arrival"]["terminalID"] = $additionalParams->TERMINAL_ID->value;
        }else{
            if($additionalParams->STREET_KLADR->value){
                $deliveryData["delivery"]["arrival"]["address"]['street'] = $additionalParams->STREET_KLADR->value;
            }else{
                $deliveryData["delivery"]["arrival"]["address"]['customStreet'] = array('code'=>$additionalParams->ALT_LOCATION_KLADR->value,'street'=>$additionalParams->STREET->value?:"Улица не указана");
            }
            if(!empty($additionalParams->DELLIN_DELIVERY_HOUSE_NUM->value))$deliveryData["delivery"]["arrival"]["address"]['house'] = $additionalParams->DELLIN_DELIVERY_HOUSE_NUM->value;
            if(!empty($additionalParams->DELLIN_DELIVERY_BUILDING_NUM->value))$deliveryData["delivery"]["arrival"]["address"]['building'] = $additionalParams->DELLIN_DELIVERY_BUILDING_NUM->value;
            if(!empty($additionalParams->DELLIN_DELIVERY_STRUCTURE_NUM->value))$deliveryData["delivery"]["arrival"]["address"]['structure'] = $additionalParams->DELLIN_DELIVERY_STRUCTURE_NUM->value;
            if(!empty($additionalParams->DELLIN_DELIVERY_FLAT_NUM->value))$deliveryData["delivery"]["arrival"]["address"]['flat'] = $additionalParams->DELLIN_DELIVERY_FLAT_NUM->value;

            $deliveryData["delivery"]["arrival"]["time"] = array(//если указан адрес
                "worktimeStart" => $additionalParams->DELLIN_DELIVERYTIME_START->value,
                "worktimeEnd"   => $additionalParams->DELLIN_DELIVERYTIME_END->value
            );
            $unloadingRequirements = array();
            if(!empty($profileSettings['unloading_type']['prop_value'])) $unloadingRequirements[] = $profileSettings['unloading_type']['prop_value'];
            if(!empty($profileSettings['unloading_transport_requirements']['prop_value'] )) $unloadingRequirements[] = $profileSettings['unloading_transport_requirements']['prop_value'];
            if(!empty($profileSettings['unloading_additional_equipment']['prop_value'] )) $unloadingRequirements[] = $profileSettings['unloading_additional_equipment']['prop_value'];
            if(!empty($unloadingRequirements)) $deliveryData["delivery"]["arrival"]['requirements'] = $unloadingRequirements;
        }

        $arPackages = $this->GetSelectedPackingTypesId('request',
            array(
                'box'=> $profileSettings['packing_for_goods_box']['prop_value'],
                'hard' => $profileSettings['packing_for_goods_hard']['prop_value'],
                'additional' => $profileSettings['packing_for_goods_additional']['prop_value'],
                'bubble' => $profileSettings['packing_for_goods_bubble']['prop_value'],
                'bag' => $profileSettings['packing_for_goods_bag']['prop_value'],
                'pallet' => $profileSettings['packing_for_goods_pallet']['prop_value'],
                'car_glass' =>$profileSettings['packing_for_goods_car_glass']['prop_value'],
                'car_parts' => $profileSettings['packing_for_goods_car_parts']['prop_value'],
                'complex_pallet' => $profileSettings['packing_for_goods_complex_pallet']['prop_value'],
                'complex_hard' => $profileSettings['packing_for_goods_complex_hard']['prop_value'],
            )
        );

        foreach($arPackages as $packageUid){
            $arPackage = array('uid'=>$packageUid,'payer'=>'sender');
            //если мешки или коробки, тоставим количество 1, т.к. поле обязательное, но мы не можем предсказать, сколько их нужно
            if($packageUid == "0x82750921BC8128924D74F982DD961379"
                || $packageUid=="0x947845D9BDC69EFA49630D8C080C4FBE"
                || $packageUid=="0xad97901b0ecef0f211e889fcf4624fed"
                || $packageUid=="0xad97901b0ecef0f211e889fcf4624fea"
            ) $arPackage['count']=1;
            $packages[] = $arPackage;
        }
        if(isset($packages)) $deliveryData["delivery"]["packages"] = $packages;
        return $deliveryData;

    }

    /**
     * @param $orderDeliveryParams
     * @param $profileSettings
     * @param $orderProducts
     * @param $deliveryType
     * @return mixed
     */
    public function createOrder($orderDeliveryParams,$profileSettings,$orderProducts,$deliveryType){
        $data = $this->getDeliveryOrderData($orderDeliveryParams,$profileSettings,$orderProducts,$deliveryType);
        $result = DellindeliveryApicore::sendApiRequest('request',$data);
        if(isset($result->data) && $result->data->state == 'success'){
            $additionalParams = json_decode($orderDeliveryParams['additional_delivery_params'],true);
            foreach($profileSettings as $param){
                if(strpos($param['prop_code'],'packing_') !== false){
                    $additionalParams['PACKAGING'][$param['prop_code']] = array(
                        'id'=>$param['prop_code'],
                        'name'=>$param['prop_name'],
                        'value'=>$param['prop_value']
                    );
                }
            }
            $additionalParams['LOADING'] = array(
                'loading_transport_requirements' => array(
                    'id' =>   $profileSettings['loading_transport_requirements']['prop_code'],
                    'name' => $profileSettings['loading_transport_requirements']['prop_name'],
                    'value'=>$profileSettings['loading_transport_requirements']['prop_value']
                ),
                'loading_additional_equipment' => array(
                    'id' =>   $profileSettings['loading_additional_equipment']['prop_code'],
                    'name' => $profileSettings['loading_additional_equipment']['prop_name'],
                    'value' => $profileSettings['loading_additional_equipment']['prop_value']
                )
            );

            $additionalParams['UNLOADING'] = array(
                'unloading_transport_requirements' => array(
                    'id' =>   $profileSettings['unloading_transport_requirements']['prop_code'],
                    'name' => $profileSettings['unloading_transport_requirements']['prop_name'],
                    'value'=> $profileSettings['unloading_transport_requirements']['prop_value']
                ),
                'unloading_additional_equipment' => array(
                    'id' =>   $profileSettings['unloading_additional_equipment']['prop_code'],
                    'name' => $profileSettings['unloading_additional_equipment']['prop_name'],
                    'value' => $profileSettings['unloading_additional_equipment']['prop_value']
                )
            );

            $additionalParams['LOADING']['loading_type'] = array(
                'id' =>   $profileSettings['loading_type']['prop_code'],
                'name' => $profileSettings['loading_type']['prop_name'],
                'value' =>  $profileSettings['loading_type']['prop_value'],
            );

            $additionalParams['UNLOADING']['unloading_type'] = array(
                'id' =>   $profileSettings['unloading_type']['prop_code'],
                'name' => $profileSettings['unloading_type']['prop_name'],
                'value' =>  $profileSettings['unloading_type']['prop_value'],

            );

            $additionalParams['TRACKER'] = array('id'=>'TRACKER','name'=>'Трек-номер','value'=>$result->data->requestID);

            $this->model_extension_shipping_dellindelivery_delivery->updateOrderProp($orderDeliveryParams['order_id'],'tracking',$result->data->requestID);
            $this->model_extension_shipping_dellindelivery_delivery->saveDeliveryParams($orderDeliveryParams['order_id'],$additionalParams);
        }
        return $result;
    }
    /**
     * @param $address
     * @param $products
     * @param $config
     * @param $arrivalKladr //Если передан, то для точки доставки используется этот кладр вместо определения по названию (необходимо при доставке от адреса до адреса перед отправкой заявки в ДЛ)
     * @return array
     */
    public function Calculate($address,$products, $config,$arrivalKladr=false)
    {
        $this->load->language('extension/shipping/dellindelivery');
        $result = array('status' => 'error', 'body' => $this->language->get('dellin_calculate_error'));
        $data = $this->GetDeliveryData($address, $products, $config, $arrivalKladr);
        if($data['status'] == "error"){
            return $data;
        }
        if ($this->IsDataValid($data, $products, $config)) {
            $response = DellindeliveryApicore::sendApiRequest('calculator',$data);
            if($response == null){
                var_dump($response);
            }
            if(isset($response)){

                if (isset($response->errors)) {
                    if($response->errors == "Unauthorized"){
                        echo "<pre>";
                        var_dump($response->errors);
                        echo "</pre>";
                        return false;
                    }
                    if (isset($response->errors->messages)) {
                        $result['BODY'] = $response->errors->messages;
                    }elseif (isset($response->errors->message)) {
                        $result['BODY'] = $response->errors->message;
                    }elseif(is_array($response->errors)){
                        $result['BODY'] = "";
                        foreach($response->errors as $index => $error){
                            $result['STATUS'] = "ERROR";
                            $result['BODY'] .= $index.": ".(isset($error->error)?$error->error:$error)." | ";
                        }
                    }
                    //тут можно записывать ошибку в лог
                /*}elseif(isset($response['status']) && $response['status']=='error'){
                    $result['STATUS'] = "ERROR";
                    $result['BODY'] = $response['body'];*/
                }else {
                    unset($this->session->data['current_terminals']);
                    foreach($response->arrival->terminals as $terminal){
                        $terminals[$terminal->id] = $terminal;
                    }
                    $this->session->data['current_terminals'] = $terminals;
                    $price = $this->CalculatePrice($response, $config);

                    /*if ($arOrder['ID'] !== null) {
                        $arOrder = DellinDelivery::GetOrder($arOrder['ID']);
                        $config = DellinDelivery::GetDeliveryConfig($arOrder['CURRENT_DELIVERY_ID']);
                    }*/
                    $arVolume = $this->CalculateVolume($products,$config);
                    $arWeight = $this->CalculateWeight($products,$config);
                    $deliveryDelay = $config['delivery_delay']['prop_value']?$config['delivery_delay']['prop_value']: 1;
                    if(isset($config['produceDate']) && $config['produceDate'] !== false){
                        $produceTimestamp = strtotime($config['produceDate']); //проверяем дату, установленную при первом расчете заказа на случай, если она отличается от настроек
                    }else{
                        $produceTimestamp = mktime(0, 0, 0, date("m")  , date("d")+$deliveryDelay, date("Y"));
                    }
                    if($produceTimestamp){
                        $produceData = array(
                            "appKey" => $config['api_key']['prop_value'],
                            "produceDate" => date("Y-m-d", $produceTimestamp), //ориентировочная минимальная дата (сегодня + дней из настроек)
                            "sizedVolume" => $arVolume['sized'],
                            "sizedWeight" => $arWeight['sized'],
                            "derivalPoint" => $config['kladr_code_delivery_from']['prop_value'],
                            "derivalDoor" => ($config['is_goods_loading']['prop_value'] == 1) ? true : false,
                            "deliveryType" => "1",
                            "derivalPeriodVisit" => array(
                                "workStart" => $config['work_start']['prop_value'],
                                "workEnd" => $config['work_end']['prop_value']
                            ),


                            "length" => ($arVolume['max_length'])? $arVolume['max_length'] : 0.01,
                            "width" => ($arWeight['max_weight'])? $arWeight['max_weight'] : 0.01,
                            "height" => ($arVolume['max_height'])? $arVolume['max_height'] : 0.01,
                        );
                        if(isset($arVolume['oversized'])) $produceData['oversizedVolume'] = $arVolume['oversized'];
                        if(isset($arWeight['oversized'])) $produceData['oversizedWeight'] = $arWeight['oversized'];
                        $produceDate = $this->GetProduceDate($produceData, $config);
                        if(isset($produceDate->errors)){
                            $result['body'] ="";
                            foreach($produceDate->errors as $key=>$error){
                                $result['body'] .= " | ".$key.": ".$error." | ";
                            }
                            return $result;
                        }
                        $nearestDate = $produceDate->nearestDate;
                        $result['status'] = 'OK';
                        $result['body'] = array($price, $response->time->nominative, $nearestDate);
                        if(isset($response->small) && $config['is_small_goods_price']['prop_value']==1 && $config['is_goods_loading']['prop_value']==1 && $config['is_goods_unloading']['prop_value']==1){
                            $result['delivery_type'] = "small";

                        }else{
                            $result['delivery_type'] = "auto";
                        }
                        if (isset($produceDate->dateChanged)) {
                            $result['dateChanged'] = $produceDate->dateChanged;
                        }
                        if(isset($produceDate->terminalTime)){
                            $result['terminalTime'] = $produceDate->terminalTime;
                        }
                    }else{
                        $result['status'] = 'error';
                        $result['body'] = $this->language->get('error_delivery_delay');
                    }

                }
            }else{
                $result['status'] = 'error';
                $result['body'] = $this->language->get('error_connection');
            }
        }
        return $result;
    }

    public function dateDifference($date_1 , $date_2 , $differenceFormat = '%a' )
    {
        $datetime1 = date_create($date_1);
        $datetime2 = date_create($date_2);
        $interval = date_diff($datetime1, $datetime2);

        return $interval->format($differenceFormat);

    }

    public function GetProduceDate($data,$deliveryConfig,$baseDate=false){
        if(!$baseDate) $baseDate = $data['produceDate'];
        $this->load->language('extension/shipping/dellindelivery');
        $produceDate = DellindeliveryApicore::sendApiRequest('produceDate',$data);
        if(!isset($produceDate)){
            return false;
        }
        if(isset($produceDate->errors)){
            return $produceDate;
        }
        if ($produceDate->produce_available) {//проверяем, возможна ли отгрузка хоть на какой-нибудь терминал в городе в эту дату
            if($deliveryConfig['is_goods_loading']['prop_value'] == 0) {
                //если да, проверяем расписание терминала
                if(!empty($deliveryConfig['terminal_id']['prop_value'])){
                    $terminal = DellindeliveryApicore::GetTerminals($deliveryConfig['api_key']['prop_value'],$deliveryConfig['kladr_code_delivery_from']['prop_value'], $deliveryConfig['terminal_id']['prop_value'])['terminal'];
                    foreach ($terminal->worktables->worktable as $worktable) {
                        $departmentname = trim($worktable->department);
                        if ($departmentname == "Приём и выдача груза" || $departmentname == "Приём груза") {
                            $weekDay = strtolower(date('l',strtotime($data['produceDate'])));
                            if ($worktable->{$weekDay} !== "-" ) {
                                if(str_replace(" ","",$worktable->{$weekDay}) == "24ч"){
                                    $startTime = "00:00";
                                    $endTime = "23:59";
                                    $workHours = array($startTime,$endTime);
                                }else{
                                    $workHours = explode("-", $worktable->{$weekDay});
                                    $startTime = strtotime(date('Y-m-d') . " " . $workHours[0]);
                                    $endTime = strtotime(date('Y-m-d') . " " . $workHours[1]);
                                }
                                $shopStartTime = strtotime($deliveryConfig['work_start']['prop_value']);
                                $shopEndTime = strtotime($deliveryConfig['work_end']['prop_value']);

                                if ($shopEndTime <= $startTime || $shopStartTime >= $endTime) {
                                    $produceDate->terminalTime = $workHours;
                                }

                                $produceDate->nearestDate = $data['produceDate'];
                                break;
                            }else{

                                $oldProduceDate = new DateTime($data['produceDate']);
                                $newProduceDate = $oldProduceDate->modify('+1 day');
                                $datediff = $this->dateDifference($newProduceDate->format('Y-m-d'),$baseDate);
                                if($datediff <=2){
                                    $data['produceDate'] = $newProduceDate->format('Y-m-d');
                                    $produceDate = $this->GetProduceDate($data,$deliveryConfig,$baseDate);
                                    $produceDate->dateChanged = true;
                                }
                            }
                        }
                    }
                    if(!isset($produceDate->nearestDate)){
                        $produceDate->produce_available = false;
                        $produceDate->errors['error_terminal_department'] = $this->language->get('error_terminal_department');
                    }
                }else{
                    $produceDate->errors['error_terminal_id'] = $this->language->get('error_terminal_id');
                }
            }else{
                $produceDate->nearestDate = $data['produceDate'];
            }

        }else{
            $oldProduceDate = new DateTime($data['produceDate']);
            $newProduceDate = $oldProduceDate->modify('+1 day');
            $datediff = $this->dateDifference($newProduceDate->format('Y-m-d'),$baseDate);
            if($datediff <=3){
                $data['produceDate'] = $newProduceDate->format('Y-m-d');
                $produceDate = $this->GetProduceDate($data,$deliveryConfig,$baseDate);
                $produceDate->dateChanged = true;
            }
            else{
                $result = new stdClass();
                return $result->errors = array('error date' => 'Отгрузка в ближайшие 2 дня от предполагаемой даты ('.$baseDate.') невозможна. Попробуйте изменить параметр "отложенная доставка" в настройках модуля');
            }
        }
        return $produceDate;
    }

    public function GetOrderStatus($profileId,$trackNum){
        if(!class_exists('DellindeliveryApicore')) $this->load->library('DellindeliveryApicore');
        $this->load->model('extension/shipping/dellindelivery/profile');
        $profileSettings = $this->model_extension_shipping_dellindelivery_setting->getSetting($profileId);
        $params = array('appkey'=>$profileSettings['api_key']['prop_value'],'docid'=>$trackNum);
        $statusResult = DellindeliveryApicore::GetStatus($params);
        if(isset($statusResult)) {
            $status = array('state'=>$statusResult->state,'state_name'=>$statusResult->state_name);
            return $status;
        }else{
            return false;
        }


    }

    /**
     * Расчет конечной стоимости.
     * @param object $response
     * @param array $arConfig
     * @return bool|float
     */
    protected static function CalculatePrice($response, $config)
    {
        $total_price = false;
        $is_small_goods_price = $config['is_small_goods_price']['prop_value'] == 1;
        if(isset($response) && $response->price > 0){
            $total_price = $response->price;
        }
        if (isset($response) && ($is_small_goods_price && isset($response->small->price) && $response->small->price > 0)) {
            $total_price = $response->small->price + $response->small->insurance + $response->small->notify->price;
            if(isset($response->packages)){
                $packages = array_diff_key(get_object_vars($response->packages), array("discount"=>"","discountDetails"=>"","premium"=>"","premiumDetails"=>"","required"=>""));
                $packagesSum = 0;
                foreach($packages as $package){
                    $packagesSum += $package;
                }
                $total_price += $packagesSum;
            }
        }
        return $total_price;
    }

    /**
     * Проверяем код на валидность.
     * @param array $data
     * @param array $products
     * @param array $config
     * @return bool
     */
    protected function IsDataValid($data, $products, $config)
    {
        $orderPrice = $this->getOrderPrice($products);
        return
            (
                $orderPrice > 0
            ) && (
                $data["appKey"] !== ''
            ) && (
                $data["derivalPoint"] !== '' &&
                $data["arrivalPoint"] !== ''
            ) &&
            (
                $config['intercity_hide']['prop_value'] == 0 || ($config['intercity_hide']['prop_value'] == 1 && ($data['derivalPoint'] != $data['arrivalPoint'] && ($config['is_goods_unloading']['prop_value']==0 || $config['is_goods_loading']['prop_value'] == 0)) || ($config['is_goods_unloading']['prop_value'] == 1 && $config['is_goods_loading']['prop_value'] == 1))
                //$config['intercity_hide']['prop_value'] == 1 && $data['derivalPoint'] == $data['arrivalPoint'] && ($config['is_goods_unloading']['prop_value']==0 || $config['is_goods_loading']['prop_value'] == 0)
            );
    }



    public function GetDeliveryData($address,$products,$config,$arrivalKladr=false)
    {
        $this->load->language('extension/shipping/dellindelivery');
        //вход в систему для получения цен с учетом систем лояльности
        if($config['login']['prop_value'] && $config['password']['prop_value']){
            $arConfig= array('api_key'=>$config['api_key']['prop_value'],'login'=>$config['login']['prop_value'],'password'=>$config['password']['prop_value']);
            $sessionId = $this->GetDellinSessionId($arConfig);
        }
        // Получаем КЛАДР код населенного пункта, из которого нужно доставить груз.
        $delivery_from_kladr_code = $config['kladr_code_delivery_from']['prop_value'];
        // Получаем КЛАДР код населенного пункта, в который нужно доставить груз.
        if($arrivalKladr){
            $delivery_to_kladr_code = $arrivalKladr;
        }else{
            if(!empty($address['city'])){
                $delivery_to_kladr_code = $this->GetCityKLADRCode($address['city']);
            }elseif(!empty($address['zone'])){
                $delivery_to_kladr_code = $this->GetCityKLADRCode($address['zone']);
                if(!$delivery_to_kladr_code){
                    $clearRegionName = preg_replace("/(область|обл.|Аобл.|край|Респ.|\(|\)|\s)/ui","",$address['zone']);
                    $delivery_to_kladr_code = DellindeliveryApicore::GetRegionKladr($config['api_key']['prop_value'],$clearRegionName);
                }
            }
        }

        if(!$delivery_to_kladr_code){
            $error = array('status'=>'error','text'=> $this->language->get('error_kladr_code_detect'));
            return $error;
        }
        $dl_api_numbers_of_cargo_places = $this->GetNumbersOfCargoPlaces($products, $config);
        // Получаем вес.
        $dl_api_weight = $this->CalculateWeight($products, $config);
        // Получаем объем.
        $dl_api_volume = $this->CalculateVolume($products, $config);

        $orderPrice = $this->getOrderPrice($products);
        // Формируем данные для отправки.
        // Полный список параметров можно найти тут:
        // http://dev.dellin.ru/api/public/calculator/
        $dl_api_data = array(
            // Ключ API (обязательное поле).
            // string
            'appKey' =>$config['api_key']['prop_value'],

            // Код КЛАДР пункта отправки (обязательное поле).
            // string
            'derivalPoint' => $delivery_from_kladr_code?$delivery_from_kladr_code:"",

            // Необходима доставка груза от адреса.
            // boolean

            'derivalDoor' => $config['is_goods_loading']['prop_value'] == 1,

            // Требуются дополнительные услуги для доставки груза от адреса - боковая погрузка
            // array
            "derivalServices" => array(),

            // Код КЛАДР пункта прибытия (обязательное поле).
            // string
            'arrivalPoint' => $delivery_to_kladr_code,

            // Необходима доставка груза до адреса.
            // boolean
            'arrivalDoor' => $config['is_goods_unloading']['prop_value'] == 1,

            // Требуются дополнительные услуги для доставки груза до адреса - боковая погрузка
            // array
            "arrivalServices" => array(),

            // Общий объём груза в кубических метрах (обязательный поле).
            // string

            'sizedVolume' =>  (string) $dl_api_volume['sized'],

            // Общий вес груза в килограммах (обязательный поле).
            // string
            'sizedWeight' => (string) $dl_api_weight['sized'],

            // Заявленная стоимость груза в рублях. При отсутсвии - груз не страхуется, при передаче 0 - страхуется без объявленной стоимости,
            // при передаче значения больше 0 - страхуется на указанную сумму.
            // float | integer
            'statedValue' => (string) round($config['is_insurance_goods_with_declared_price']['prop_value'] == 1 ? (float)$orderPrice : 0,1,PHP_ROUND_HALF_EVEN),

            // Упаковать груз в упаковку?
            // array
            'packages' => $this->GetSelectedPackingTypesId('calculator',array(
                'box'=> $config['packing_for_goods_box']['prop_value'],
                'hard' => $config['packing_for_goods_hard']['prop_value'],
                'additional' => $config['packing_for_goods_additional']['prop_value'],
                'bubble' => $config['packing_for_goods_bubble']['prop_value'],
                'bag' => $config['packing_for_goods_bag']['prop_value'],
                'pallet' => $config['packing_for_goods_pallet']['prop_value'],
                'car_glass' =>$config['packing_for_goods_car_glass']['prop_value'],
                'car_parts' => $config['packing_for_goods_car_parts']['prop_value'],
                'complex_pallet' => $config['packing_for_goods_complex_pallet']['prop_value'],
                'complex_hard' => $config['packing_for_goods_complex_hard']['prop_value'],
            )),
            // Количество мест, по-умолчанию расчет производится для одного места.
            // integer
            'quantity' => $dl_api_numbers_of_cargo_places,
            'productInfo'=>array(
                'type'=> 4,
                'productType'=> 5,
                'info'=>array(
                    array(
                        'param'=> 'module version',
                        'value'=> 'beta'
                    )
                )
            )

        );
        if($config['packing_for_goods_car_glass']['prop_value'] == 1){
            $dl_api_data['protect_auto_glass_count'] = 1;
        }
        if($config['packing_for_goods_car_parts']['prop_value'] == 1){
            $dl_api_data['protect_auto_part_count'] = 1;
        }
        if($config['packing_for_goods_car_glass']['prop_value'] == 1){
            $dl_api_data['protect_auto_glass_count'] = 1;
        }
        if($config['packing_for_goods_car_parts']['prop_value'] == 1){
            $dl_api_data['protect_auto_part_count'] = 1;
        }


        if(strlen($config['counteragent']['prop_value']) !== 0){
            $dl_api_data['cauid'] = $config['counteragent']['prop_value'];
        }
        if(isset($sessionId)){
            //id сессии авторизации
            $dl_api_data['sessionId'] = $sessionId;
        }
        // Если есть перегруз или негаборит, то добавим эти параметры.
        if (isset($dl_api_volume['oversized']) || isset($dl_api_weight['oversized'])) {
            $dl_api_data['oversizedVolume'] = $dl_api_volume['sized'];
            $dl_api_data['oversizedWeight'] = $dl_api_weight['sized'];
        }
        // Добавляем дополнительные услуги, если отмечена галочка, что необходима погрузка товара
        if (isset($dl_api_data['derivalDoor'])){
            $dl_api_data['derivalServices'] = $this->GetAdditionalServices(array(
                $config['loading_type']['prop_value'],
                $config['loading_transport_requirements']['prop_value'],
                $config['loading_additional_equipment']['prop_value']
            ));
        }
        // Добавляем дополнительные услуги, если отмечена галочка, что необходима разгрузка товара
        if ($dl_api_data['arrivalDoor']) {
            $dl_api_data['arrivalServices'] = self::GetAdditionalServices(array(
                $config['unloading_type']['prop_value'],
                $config['unloading_transport_requirements']['prop_value'],
                $config['unloading_additional_equipment']['prop_value']
            ));
        }
        $dl_api_data['status']="ok";
        return $dl_api_data;
    }

    /**
     * Получаем значения для поля "{arrival-derival}Services"
     * @param array $fields
     * @return array
     */
    protected static function GetAdditionalServices($fields)
    {
        $value_list = array();

        foreach ($fields as $item) {
            if (strlen($item) == 0) {
                continue;
            }

            $value_list[] = $item;
        }
        return $value_list;
    }

    /**
     * Получаем массив из id типов упаковки.
     * @param array $fields
     * @return array
     */
    protected static function GetSelectedPackingTypesId($requestType, $fields)
    {
        if($requestType == 'calculator'){
            $packagesArray = DellindeliveryApicore::$packing_types_id;
        }elseif($requestType == 'request'){
            $packagesArray = DellindeliveryApicore::$request_packages_id;
        }

        $value_list = array();

        foreach ($fields as $key => $value) {
            if ($value == 0) {
                continue;
            }

            $value_list[] = $packagesArray[$key];
        }
        return $value_list;
    }

    public function GetOrderPrice($products){
        $totalPrice = 0;
        foreach($products as $product){
            $totalPrice += $product['total'];
        }
        return $totalPrice;
    }

    /**
     * Определяем параметры "sizedVolume" и "oversizedVolume" по способу группировки груза
     * @param array $products
     * @param array $arConfig
     * @return array
     */
    public function CalculateVolume($products, $arConfig) {
        $arVolume = array();

        $totalVolume = 0;
        $totalOversizedVolume = 0;
        $maxLength = 0;
        $maxWidth = 0;
        $maxHeight = 0;
        //для деловых линий все ДШВ должны быть указаны в мм, поэтому ищем эту единицу среди ед. измерения
        foreach ($products as $product) {
            $length = (int) $this->convertToMM($product['length'],$product['length_class_id'])?:0;
            if($length > $maxLength) $maxLength = $length;
            $width = (int)  $this->convertToMM($product['width'],$product['length_class_id'])?:0;
            if($width > $maxWidth) $maxWidth = $width;
            $height = (int)  $this->convertToMM($product['height'],$product['length_class_id'])?:0;
            if($height > $maxHeight) $maxHeight = $height;
            $totalVolume += $product['quantity'] * $length * $width * $height;
        }

        $totalVolume = DellindeliveryApicore::ConvertVolumeFromCubicMillimeterToCubicMeter($totalVolume);
        switch ($arConfig['loading_grouping_of_goods']['prop_value']) {
            // Если считаем весь заказ, как 1 грузоместо.
            case 'one_cargo_space':
                $max_size = array('length' => 0, 'width' => 0, 'height' => 0);

                foreach ($products as $product) {
                    $length = $this->convertToMM($product['length'],$product['length_class_id']);
                    $width = $this->convertToMM($product['width'],$product['length_class_id']);
                    $height = $this->convertToMM($product['height'],$product['length_class_id']);
                    if ($length > $max_size['length']) {
                        $max_size['length'] = $length;
                    }

                    if ($width > $max_size['width']) {
                        $max_size['width'] = $width;
                    }

                    if ($height > $max_size['height']) {
                        $max_size['height'] = $height;
                    }
                }

                $arVolume = DellindeliveryApicore::GetVolumeArrayBySize($max_size, $totalVolume, $totalVolume);
                break;

            // Если группируем каждый вид товара, как отдельное грузоместо.
            case 'separated_cargo_space':
                foreach ($products as $product) {
                    $length = $this->convertToMM($product['length'],$product['length_class_id']);
                    $width = $this->convertToMM($product['width'],$product['length_class_id']);
                    $height = $this->convertToMM($product['height'],$product['length_class_id']);
                    $volume = $product['quantity'] * $length * $width * $height;

                    if (DellindeliveryApicore::IsOversizedVolume($volume)) {
                        $totalOversizedVolume += $volume;
                    }
                }

                $arVolume = DellindeliveryApicore::GetVolumeArrayByVolume(
                    $totalOversizedVolume,
                    $totalVolume,
                    DellindeliveryApicore::ConvertVolumeFromCubicMillimeterToCubicMeter($totalOversizedVolume)
                );
                break;

            // Если каждая единица товара - отдельное грузоместо.
            case 'single_item_single_space':
                foreach ($products as $product) {
                    $length = $product['length'];
                    $width = $product['width'];
                    $height = $product['height'];

                    $volume = $length * $width * $height;

                    if (DellindeliveryApicore::IsOversizedVolume($volume)) {
                        $totalOversizedVolume += $volume;
                    }
                }

                $arVolume = DellindeliveryApicore::GetVolumeArrayByVolume(
                    $totalOversizedVolume,
                    $totalVolume,
                    DellindeliveryApicore::ConvertVolumeFromCubicMillimeterToCubicMeter($totalOversizedVolume)
                );
                break;
        }
        if(empty($arVolume) || $arVolume['sized']<=0.001){
            $arVolume['sized'] = 0.001;
        }
        $arVolume['max_height'] = $maxHeight;
        $arVolume['max_width'] = $maxWidth;
        $arVolume['max_length']= $maxLength;
        return $arVolume;
    }

    /**
     * Определяем параметры "sizedWeight" и "oversizedWeight" по способу группировки груза
     * @param array $arOrder
     * @param array $arConfig
     * @return array
     */
    public function CalculateWeight($products, $arConfig)
    {
        if(!class_exists('DellindeliveryApicore')) $this->load->library('DellindeliveryApicore');
        $arWeight = array();
        switch ($arConfig['loading_grouping_of_goods']['prop_value']) {
            // Если считаем весь заказ, как 1 грузоместо.
            case 'one_cargo_space':
                $sumItemWeight = 0;
                $maxItemWeight = 0;
                foreach($products as $product){
                    $product['weight'] = $this->convertWeightGtoKG( $product['weight'],$product['weight_class_id']);//на количество не умножается, потому что тут уже суммарный вес хранится
                    if($product['weight'] > $maxItemWeight) $maxItemWeight = $product['weight'];
                    $sumItemWeight += $product['weight']*$product['quantity'];
                }
                $arWeight = $this->GetWeightArray($sumItemWeight);
                break;

            // Если группируем каждый вид товара, как отдельное грузоместо.
            case 'separated_cargo_space':
                $maxItemWeight = 0;
                $sumItemWeight = 0;
                foreach ($products as $product) {
                    $product['weight'] = $this->convertWeightGtoKG($product['weight'],$product['weight_class_id']);
                    $sumItemWeight += $product['weight'];

                    if ($product['weight'] > $maxItemWeight) {
                        $maxItemWeight = $product['weight'];
                    }
                }

                $arWeight = $this->GetWeightArray($maxItemWeight, $sumItemWeight);
                break;

            // Если каждая единица товара - отдельное грузоместо.
            case 'single_item_single_space':
                $maxItemWeight = 0;
                $sumItemWeight = 0;

                foreach ($products as $product) {
                    $sumItemWeight += $product['weight'];
                    $oneItemWeight = $product['weight']/$product['quantity'];
                    if ($oneItemWeight > $maxItemWeight) {
                        $maxItemWeight = $oneItemWeight;
                    }
                }

                $arWeight = $this->GetWeightArray($maxItemWeight, $sumItemWeight);
                break;
        }
        if(empty($arWeight)) $arWeight['sized'] = 0.1;
        $arWeight['max_weight'] = $maxItemWeight;
        return $arWeight;
    }

    public function convertWeightGtoKG($weight,$weightClassId){
        $currencyName =  $this->db->query('SELECT unit FROM '.DB_PREFIX.'weight_class_description WHERE weight_class_id='.$weightClassId);
        if($currencyName->row['unit'] == "г"){
            $weight = $weight/1000;
        }
        return $weight;
    }
    public function convertToMM($length,$lengthClassId){
        if($this->language->get('code') == 'ru'){
            if($this->length->getUnit($lengthClassId) == 'см'){
                $length = $length*10;
            }
            if($this->length->getUnit($lengthClassId) == 'м'){
                $length = $length*1000;
            }
        }
        return $length;
    }



    /**
     * Получаем массив с параметрами веса, основываясь на перегрузе
     * @param float $compare_weight
     * @param null|float $ set_weight
     * @return array
     */
    public static function GetWeightArray($compare_weight, $set_weight = null) {
        $total_weight = is_null($set_weight) ? $compare_weight : $set_weight;

        if (DellindeliveryApicore::IsOversizedWeight($compare_weight)) {
            return array('sized' => $total_weight, 'oversized' => $total_weight);
        }

        return array('sized' => $total_weight);
    }


    /**
     * Рассчитываем кол-во грузовых мест.
     * @param array $products
     * @param array $arConfig
     * @return int
     */
    protected static function GetNumbersOfCargoPlaces($products, $arConfig)
    {

        $numbers_of_places = 1;

        switch ($arConfig['loading_grouping_of_goods']['prop_value']) {
            // Если считаем весь заказ, как 1 грузоместо.
            case 'one_cargo_space':
                $numbers_of_places = 1;
                break;

            // Если группируем каждый вид товара, как отдельное грузоместо.
            case 'separated_cargo_space':
                $numbers_of_places = count($products);
                break;

            // Если каждая единица товара - отдельное грузоместо.
            case 'single_item_single_space':
                $numbers_of_places = 0;
                foreach ($products as $product) {
                    $numbers_of_places += $product['quantity'];
                }
                break;
        }
        return $numbers_of_places;
    }


    /**
     * Получаем id авторизации
     * @param $arConfig
     * @return bool|string
     * @throws Exception
     */
    public static function getDellinSessionId($arConfig){
        if($arConfig['login'] && $arConfig['password']){
            $life_time = 30*24*60*60;
            $cache_id = 'dellinSessionId';
            $cache = new Cache('file',$life_time);
            if(!$cache->get($cache_id)){
                $data = array(
                    'appkey'   => $arConfig['api_key'],
                    'login'    => $arConfig['login'],
                    'password' => $arConfig['password']
                );
                $result = DellindeliveryApicore::sendApiRequest('login',$data);
                if(isset($result->sessionID)){
                    $sessionId = $result->sessionID;
                    $cache->set($cache_id,$sessionId);
                }else{
                    return false;
                }

            }else{
                $sessionId = $cache->get($cache_id);
            }

            return $sessionId;
        }
        else{
            return false;
        }
    }

    /**
     * Получаем КЛАДР по названию города (области)
     * @param $locationName
     * @return bool|string
     */
    public function GetCityKLADRCode($locationName)
    {
        if (isset($locationName)) {
            $arName = explode(" ", trim($locationName));
            if ($arName > 3) {
                usort($arName, array('ModelExtensionShippingDellindelivery', 'sort_func'));
                $searchString = implode(" ", array_slice($arName, 0, 2));
                $locationName = $searchString;
            }
            $this->load->library('DellindeliveryApicore');
            $dl_locations = DellindeliveryApicore::SearchCity($locationName);
            if(empty($dl_locations)) return false;
        }

        if (count($dl_locations) > 0) {
            $dl_city = DellindeliveryApicore::SelectCityByRegion($dl_locations,$locationName);
            $kladr_code = (string)$dl_city->code;
        } else {
            return $dl_locations->errors;
        }
        return $kladr_code;
    }



    private static function sort_func($a,$b)
    {
        if (strlen($a) == strlen($b))
        {
            //  return 0;
        }

        return (strlen($a) > strlen( $b)) ? -1 : 1;
    }
    public function plural($n, $form1, $form2, $form3) {
        return in_array($n % 10, array(2,3,4)) && !in_array($n % 100, array(11,12,13,14)) ? $form2 : ($n % 10 == 1 ? $form1 : $form3);
    }
}
?>